=== debian/changelog ===
dupd (1.7.3-3) unstable; urgency=medium

  * Fix autopkgtest

 -- Ermakov Alexander <ermakovav@altgtu.ru>  Thu, 26 Feb 2026 09:34:35 +0700

dupd (1.7.3-2) unstable; urgency=medium

  * Forwarded patches
  * Add bash completion
  * Add autopkgtest
  * Watch version 5 (trivial update)
  * Std-ver 4.7.3 (trivial update)
  [ Alex Myczko ]
  * d/control: set Architecture to any.

 -- Ermakov Alexander <ermakovav@altgtu.ru>  Tue, 24 Feb 2026 15:25:44 +0700

dupd (1.7.3-1) unstable; urgency=medium

  * Initial release. (Closes: #901944)

 -- Ermakov Alexander <ermakovav@altgtu.ru>  Fri, 19 Sep 2025 15:43:22 +0700
