=== debian/control ===
Source: dupd
Maintainer: Ermakov Alexander <ermakovav@altgtu.ru>
Section: utils
Build-Depends:
 debhelper-compat (= 13),
 bash-completion,
 libsqlite3-dev,
 libssl-dev,
Standards-Version: 4.7.3
Homepage: https://github.com/jvirkki/dupd
Vcs-Browser: https://github.com/ermakov0/dupd
Vcs-Git: https://github.com/ermakov0/dupd.git

Package: dupd
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 bash-completion,
Description: duplicate file finder CLI utility
 dupd enables an exploratory approach to finding duplicates in your
 filesystems instead of only showing a static list of duplicate
 files. See the docs directory for more information and examples.
 .
 dupd also seeks to be fast. For most file sets it performs better than
 other popular tools.
