=== debian/rules ===
#!/usr/bin/make -f

# See debhelper(7) (uncomment to enable).
# Output every command that modifies files on the build system.
# export DH_VERBOSE = 1

export DPKG_EXPORT_BUILDFLAGS = 1
export DEB_BUILD_HARDENING = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
include /usr/share/dpkg/buildflags.mk
export CFLAGS += $(CPPFLAGS)

export INSTALL_PREFIX = /usr

%:
	dh $@ --with bash-completion

# already install into /usr/share/man/
override_dh_auto_install:
	dh_auto_install
	rm -rf debian/dupd/usr/man/

# use autopkgtest instead
override_dh_auto_test:

override_dh_compress:
	dh_compress -X.md
