=== debian/tests/control ===
Test-Command: cd tests && ./run
Depends:
 sqlite3,
 @,
