=== debian/watch ===
Version: 5

Template: Github
Owner: jvirkki
Project: dupd
